Package com.io7m.coffeepick.runtime

# Class RuntimeVersion.Builder

java.lang.Object
com.io7m.coffeepick.runtime.RuntimeVersion.Builder

Enclosing class:
  RuntimeVersion

    public static final class RuntimeVersion.Builder
    extends java.lang.Object

Builds instances of type `RuntimeVersion`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `RuntimeVersion` | `build()` | Builds a new `RuntimeVersion`.
  `RuntimeVersion.Builder` | `from​(RuntimeVersionType instance)` | Fill a builder with attribute values from the provided `RuntimeVersionType` instance.
  `RuntimeVersion.Builder` | `setBuild​(java.math.BigInteger build)` | Initializes the optional value `build` to build.
  `RuntimeVersion.Builder` | `setBuild​(java.util.Optional<? extends java.math.BigInteger> build)` | Initializes the optional value `build` to build.
  `RuntimeVersion.Builder` | `setMajor​(java.math.BigInteger major)` | Initializes the value for the `major` attribute.
  `RuntimeVersion.Builder` | `setMinor​(java.math.BigInteger minor)` | Initializes the value for the `minor` attribute.
  `RuntimeVersion.Builder` | `setPatch​(java.math.BigInteger patch)` | Initializes the value for the `patch` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final RuntimeVersion.Builder from​(RuntimeVersionType instance)
    Fill a builder with attribute values from the provided `RuntimeVersionType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setMajor

    public final RuntimeVersion.Builder setMajor​(java.math.BigInteger major)
    Initializes the value for the `major` attribute.
    Parameters:
      `major` - The value for major
    Returns:
      `this` builder for use in a chained invocation

  - ### setMinor

    public final RuntimeVersion.Builder setMinor​(java.math.BigInteger minor)
    Initializes the value for the `minor` attribute.
    Parameters:
      `minor` - The value for minor
    Returns:
      `this` builder for use in a chained invocation

  - ### setPatch

    public final RuntimeVersion.Builder setPatch​(java.math.BigInteger patch)
    Initializes the value for the `patch` attribute.
    Parameters:
      `patch` - The value for patch
    Returns:
      `this` builder for use in a chained invocation

  - ### setBuild

    public final RuntimeVersion.Builder setBuild​(java.math.BigInteger build)
    Initializes the optional value `build` to build.
    Parameters:
      `build` - The value for build
    Returns:
      `this` builder for chained invocation

  - ### setBuild

    public final RuntimeVersion.Builder setBuild​(java.util.Optional<? extends java.math.BigInteger> build)
    Initializes the optional value `build` to build.
    Parameters:
      `build` - The value for build
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public RuntimeVersion build()
    Builds a new `RuntimeVersion`.
    Returns:
      An immutable instance of RuntimeVersion
    Throws:
      `java.lang.IllegalStateException` - if any required attributes are missing